/************************************************************************/
/* @file   aes.h                                                        */
/* @author yangx                                                        */
/* @date   2022-4-12                                                    */
/* @brief  functions for AES-128 algorithm masked by code-based masking */ 
/*         proposed in XXXXXXXXXXXXXXXXXXX                              */
/************************************************************************/

#ifndef AES_H
#define AES_H

#include "common.h"

void getRand(); // get all the random numbers utilized in AES-128 from TRNG
void encodeKeys(uint8* keys, uint8* maskedKeys); // encode keys of the 11 AES-128 rounds
void rawKeyExpansion(uint8* key, uint8* keys); // key expansion
extern void AES_Encrypt_GCB(uint8* dst); // AES-128 in assembly

#endif
