/********************************************/
/* @file   random.c                         */
/* @author yangx                            */
/* @date   2022-4-12                        */
/* @brief  functions for TRNG of STM32F407. */
/********************************************/

#include <stm32f4xx.h>
#include <stm32f4xx_rcc.h>

#include "common.h"

// initialize RNG
void initRandSrc()
{
	// RNG Peripheral enable
	RCC_AHB2PeriphClockCmd(RCC_AHB2Periph_RNG, ENABLE);
	RNG_Cmd(ENABLE);
}

// generate a random 32-bit number
void genRand(unsigned int* res)
{
	//Wait until one RNG number is ready
	while (RNG_GetFlagStatus(RNG_FLAG_DRDY) == RESET) {}

	//Get a 32bit Random number
	*res = RNG_GetRandomNumber();
}

// generate a random byte
void genRandByte(uint8* res)
{
	//Wait until one RNG number is ready
	while (RNG_GetFlagStatus(RNG_FLAG_DRDY) == RESET) {}

	//Get a 32bit Random number
	*res = (uint8)RNG_GetRandomNumber();
}