/************************************************************************/
/* @file   DWT_clock.c                                                  */
/* @author Sylvain                                                      */
/* @date   2021-3-21                                                    */
/* @brief  functions for clock cycle counting in STM32F407              */
/************************************************************************/

#include "stm32f4xx_conf.h"
#include "stm32f4xx.h"   //pour le trigger
#include "common.h"

//*  Global variables for to set the cycle counter  */
volatile unsigned int *DWT_CYCCNT     = (volatile unsigned int *)0xE0001004; //address of the register
volatile unsigned int *DWT_CONTROL    = (volatile unsigned int *)0xE0001000; //address of the register
volatile unsigned int *SCB_DEMCR      = (volatile unsigned int *)0xE000EDFC; //address of the register

/* Initialize Counter */
void InitCYCCNT(){
	    *SCB_DEMCR = *SCB_DEMCR | 0x01000000;
		*DWT_CYCCNT = 0; // reset the counter
}

/* Initialize Counter */
void ResetCYCCNT(){
		*DWT_CYCCNT = 0; // reset the counter
}

/* start counter */
void StartCYCCNT(){
		*DWT_CONTROL = *DWT_CONTROL | 1 ; // enable the counter
}

/* start counter */
uint32_t  ReadCYCCNT(){
	return *DWT_CYCCNT;
}