.section .data  
.section .text
.syntax unified
.thumb
.global byte_mul_and_Eor

/* input */
/* r0 stores the address of factor1 */
/* r1 stores the address of factor2 */
/* r2 stores the number of iterations */

/* output */
/* r0 stores the eor result */
byte_mul_and_Eor:
		/* copy registers value to the stack */
		PUSH {R1,R2,R3,R4,R5,R6,R7,R11,R12}
		/* r0 stores the address of factor1 */
		/* r1 stores the address of factor2 */
		/* r2 stores the number of iterations */
		
		/* prepare the tables address */
		LDR R3, =bhtable
		LDR R4, =bltable
		
		MOV R12, #0 // counter for iterations
		MOV R11, #0 // store the eor result
loopMul:
		LDRB R5, [R0, R12] // load factor1
		LDRB R6, [R1, R12] // load factor2
		// look up tables
		LSL R5, R5, #4
		ORR R7, R5, R6, LSR #4
		LDRB R7, [R3, R7]
		AND R6, R6, #0xF
		ORR R6, R5, R6
		LDRB R6, [R4, R6]
		EOR R6, R7
		// eor
		EOR R11, R6
		
		ADD R12, #1
		CMP R12, R2
		IT NE
		BNE loopMul
		
        /* return the result */
		MOV R0, R11
		
		/* copy registers value from the stack */
		POP {R1,R2,R3,R4,R5,R6,R7,R11,R12}
		/* return */
		BX LR
.end
	