/***************************************************************/
/* @file   common.h                                            */
/* @author yangx                                               */
/* @date   2022-4-12                                           */
/* @brief  global variables and instructions for communication */
/***************************************************************/

#ifndef COMMON_H
#define COMMON_H

#define CLA 0x80

#define INS_MAKE_AES_KEY 0x12
#define INS_ENCRYPT_AES  0x04
#define INS_GET_RESPONSE 0x10
#define INS_TEST         0x81

#define P1_MAKE_AES_KEY  0x00
#define P1_ENCRYPT_AES   0x04
#define P1_GET_RESPONSE  0x00

#define P2_MAKE_AES_KEY  0x00
#define P2_ENCRYPT_AES   0x00
#define P2_GET_RESPONSE  0x00

#define KEY_LEN          0x10
#define PTEXT_LEN        0x10
#define CTEXT_LEN        0x10

typedef unsigned char uint8;

extern unsigned int sys_val;

extern uint8 key_aes[16];
extern uint8 pt_aes[16];
extern uint8 keys[176];

extern int n;
extern int k;
extern int m;
extern int L;

#endif
