/***********************************************/
/* @file   trigger.c                           */
/* @author yangx                               */
/* @date   2022-4-25                           */
/* @brief  functions for trigger in STM32F407. */
/***********************************************/

#include <stm32f4xx_rcc.h>
#include "trigger.h"

extern void trig1(); // high level 
extern void trig0(); // low level

/************************************************************************/
/*                           Public Function                            */
/************************************************************************/

void trigger_init()
{
	GPIO_InitTypeDef GPIO_InitStructure;

	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_7;  // Pin 7 used
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_OUT;  // Push-pull output
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;		// this defines the IO speed and has nothing to do with the baudrate!
	GPIO_InitStructure.GPIO_OType = GPIO_OType_PP;			// this defines the output type as push pull mode (as opposed to open drain)
	GPIO_InitStructure.GPIO_PuPd = GPIO_PuPd_UP;

	RCC_AHB1PeriphClockCmd(RCC_AHB1Periph_GPIOA, ENABLE);

	GPIO_Init(GPIOA, &GPIO_InitStructure);
}

void trigger_1()
{
	trig1();
}

void trigger_0()
{
	trig0();
}







