/***********************************************************/
/* @file   gene_Decode.s                                   */
/* @author yangx                                           */
/* @date   2022-4-25                                       */
/* @brief  Implementation of decoding in masked domain.    */
/*         The generator matrix can be fed with any input. */
/***********************************************************/

.section .data	
.section .text
.syntax unified
.thumb
.global gene_Decode
gene_Decode:
		/* copy registers value to the stack */
		PUSH {R0,R1,R2,R3,R4,R5,R6,R12,LR}
		/* r0 stores the address of vector to be decoded */
		/* r1 stores the address of result */
		
		/* fix some Regs */
		MOV R4, R0
		MOV R5, R1
		LDR R2, =n
		LDRB R2, [R2]
		LDR R3, =k
		LDRB R3, [R3]
		LDR R1, =matAInvSubSub
		SUB R2, R2, R3
		
		MOV R12, #0 // counter
loopk:
		ADD R0, R4, R3 // prepare the address of vec1
		// r1 already stores the address of vec2
		// r2 already stores the iterations : n - k
		BL byte_mul_and_Eor
		// r0 stores the result
		LDRB R6, [R4, R12] // prepare the byte mutiplied by 1
		EOR R0, R6
		STRB R0, [R5, R12]
		// loop block
		ADD R12, #1
		ADD R1, R2
		CMP R12, R3 // loop <= k
		IT NE
		BNE loopk

		/* copy registers value from the stack */
		POP {R0,R1,R2,R3,R4,R5,R6,R12,LR}
		/* return */
		BX LR
.end
	